#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "ranlib.h"

void main(void){
   int i,j,k,l,vars,vecs,paths;
   float *mean,**cov,*vec,*parm,*scratch,*val,*init_val;
   char phrase[100];
   long seed1, seed2;
   
   printf("Enter the number of variables (then return): ");
   scanf("%i",&vars);

   mean = (float*)calloc(vars,sizeof(float));
   cov = (float**)calloc(vars,sizeof(float*));
   for(i=0;i<vars;i++)
     cov[i] = (float*)calloc(vars,sizeof(float));
   vec = (float*)calloc(vars,sizeof(float));
   parm = (float*)calloc(vars*(vars+3)/2 +1,sizeof(float));
   scratch = (float*)calloc(vars*vars,sizeof(float));
   val = (float*)calloc(vars,sizeof(float));
   init_val = (float*)calloc(vars,sizeof(float));
   
   printf("\nEnter the mean vector:\n(%i whitespace seperated numbers)\n",vars);
   for(i=0;i<vars;i++)
     scanf("%f",mean+i);
   printf("\nEnter the covariance matrix:\n(%i lines of %i whitespace seperated numbers)\n",vars,vars);
   for(i=0;i<vars;i++)
     for(j=0;j<vars;j++)
       scanf("%f",cov[i]+j);
   
   printf("How many paths do you want? ");
   scanf("%i",&paths);
   
   printf("How many vectors do you want for each path? ");
   scanf("%i",&vecs);
   
   printf("Enter the initial value of each variable:\n(%i whitespace seperated numbers)\n",vars);
   for(i=0;i<vars;i++)
     scanf("%f",init_val +i);
   
   printf("Type garbage to seed the random number generator:\n(up to 100 characters then return\n");
   scanf("%s",phrase);

   printf("\nHere is what you entered:\n");
   printf("mean:\n");
   for(i=0;i<vars;i++)
     printf("%8f, ",mean[i]);
   printf("\n");
   printf("cov:\n");
   for(i=0;i<vars;i++){
      for(j=0;j<vars;j++)
        printf("%8f, ",cov[i][j]);
      printf("\n");
   }
   printf("Initial values:\n");
   for(i=0;i<vars;i++)
     printf("%8f, ",val[i]);
   printf("\n");
   printf("You want %i paths with %i vectors\n",paths,vecs);
   printf("\n");
   printf("\nHere are your paths\n");

   k = 0;
   for(i=0;i<vars;i++){
      for(j=0;j<vars;j++){
	 scratch[k] = cov[i][j];
	 k++;
      }
   }

   setgmn(mean,scratch,(long)vars,parm);
   phrtsd(phrase,&seed1,&seed2);
   setall(seed1,seed2);

   for(k=1;k<=paths;k++){
      for(l=0;l<vars;l++)
	val[l] = init_val[l];
     
      for(i=0;i<vars;i++)
        printf("%8f, ",val[i]);
      printf("\n");
      for(i=1;i<=vecs;i++){
         genmn(parm,vec,scratch);
         for(j=0;j<vars;j++){
            val[j] = exp(vec[j])*val[j];
            printf("%8f, ",val[j]);
         }
         printf("\n");
      }
      printf("\n");
   }
}
